> ## Documentation Index
> Fetch the complete documentation index at: https://kb.talostrading.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Market open interest

> Returns a WebSocket stream of open interests for specified markets.<br/> If you are falling behind (slow client) you will get `warning` message first, then `error` message and disconnection will happen.<br/><br/> <b>Note:</b> The `value_usd` field in this endpoint was previously calculated using hardcoded logic that no longer reflects current contract specifications across all exchanges.<br/><br/> To address this, we have deprecated the `value_usd` field and introduced new, more accurate metrics available via the `/timeseries/market-metrics` endpoint.<br/><br/> These two metrics should be used as a replacement for the `value_usd` field going forward:<br/> - `open_interest_reported_future_usd` to represent the notional value of open interest in U.S. dollars for futures markets<br/> - `open_interest_reported_option_notional_usd` to represent the notional value of open interest in U.S. dollars for options markets<br/><br/> We also introduced `open_interest_reported_option_market_value_usd` to represent the market value of open interest in U.S. dollars for options markets.



## OpenAPI

````yaml /coinmetrics/openapi/coinmetrics.yaml get /timeseries-stream/market-openinterest
openapi: 3.0.2
info:
  title: Coin Metrics API v4
  description: >-
    [Coin Metrics Homepage](https://coinmetrics.io/)<br/> [API Backward
    Compatibility
    Policy](https://docs.coinmetrics.io/access-our-data/api#backward-compatibility)<br/>
    [Python API
    Client](https://coinmetrics.github.io/api-client-python/site/index.html)<br/><br/>

    HTTP API root endpoint URL is `https://api.coinmetrics.io/v4`. Coin
    Metrics&apos; paid product.<br/> WebSocket API root endpoint is
    `wss://api.coinmetrics.io/v4`. Coin Metrics&apos; paid product.<br/><br/>
    The Community HTTP API root endpoint URL is
    `https://community-api.coinmetrics.io/v4`. API key is not required when
    accessing community endpoints. Available to the community under the
    [Creative Commons](https://creativecommons.org/licenses/by-nc/4.0/) license.

    # Authentication

    <!-- ReDoc-Inject: <security-definitions> -->

    # Response headers

    Note that Coin Metrics API responses have a `CF-RAY` HTTP header e.g.
    `88a6ec1d2f930774-IAD` which can be used for diagnostic purposes. When
    raising Support requests, please ensure to provide the value of this
    header. 
  termsOfService: https://coinmetrics.io/api/terms
  contact:
    name: Coin Metrics Support
    url: https://coinmetrics.io/support/
    email: support@coinmetrics.io
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.html
  version: 4.0.0
servers:
  - url: https://api.coinmetrics.io/v4
  - url: wss://api.coinmetrics.io/v4
  - url: https://community-api.coinmetrics.io/v4
security: []
tags:
  - name: Rate limits
    description: >-
      To ensure the quality of Coin Metrics services, API is subject to rate
      limiting.<br/> <table> <tr><th>Rate Limit Plan</th><th>REST API: Requests
      per Second (sliding window)</th><th>REST API: Download Speed</th><th>REST
      API: Max Parallel Requests</th><th>WebSocket API: Max Parallel
      Connections</th></tr> <tr><td>Community</td><td>10 requests per 6 seconds
      per IP address</td><td>Reduced speed</td><td>10</td><td>N/A</td></tr>
      <tr><td>Trial</td><td>10 requests per 6 seconds per API key</td><td>Max
      speed</td><td>10</td><td>200</td></tr> <tr><td>Default (PRO)</td><td>6000
      requests per 20 seconds per API key</td><td>Standard
      speed</td><td>10</td><td>200</td></tr> <tr><td>Download (PRO)</td><td>6000
      requests per 20 seconds per API key</td><td>Max
      speed</td><td>10</td><td>200</td></tr> </table> <br/> All PRO keys by
      default get the "default" rate limits. To download historical data at max
      speed, you need to switch to the "download" plan. <br/> <br/> The paid and
      community versions of the API have a limit of 10 parallel REST API
      requests. After this limit is reached, further parallel requests will be
      queued, so performance will be slower.<br/> <br/> If you reach the
      request-per-second limit, API starts to return `429 Too Many Requests`
      HTTP response status.<br/> API also provides `X-RateLimit-*` response
      headers formatted according to
      https://tools.ietf.org/html/draft-polli-ratelimit-headers-03.<br/>
      Additionally, the API provides the `X-RateLimit-Plan` header which
      indicates the current rate limiting plan. This header may have values:
      `default`, `trial`, `download`, or `community`.
    x-cm-gitbook:
      foldIntoInfo: true
  - name: Reference Data
    description: Metadata information of entities supported by Coin Metrics.
    x-cm-gitbook:
      tag: Meta Data
      icon: book
  - name: Catalog
    x-displayName: Catalog (deprecated)
    description: >-
      Catalog of available for your `api_key` data.<br/> Use the [Full
      catalog](#tag/Full-catalog) endpoints for the full list of supported by
      Coin Metrics data. <br/>DEPRECATED: See
      https://coinmetrics.io/important-changes-to-coin-metrics-api-catalog-endpoints/.
    x-cm-gitbook:
      remove: true
  - name: Catalog v2
    description: >-
      Catalog of available for your `api_key` data.<br/> Use the [Full catalog
      V2](#tag/Full-catalog-v2) endpoints for the full list of supported by Coin
      Metrics data.
    x-cm-gitbook:
      icon: list-check
  - name: Full catalog
    x-displayName: Full catalog (deprecated)
    description: >-
      The Full catalog returns the full range of data that is supported by Coin
      Metrics across all our products.<br/> If you are a client looking to
      understand the data that is available for your API key and data license,
      please use the [Catalog](#tag/Catalog) endpoint. <br/>DEPRECATED: See
      https://coinmetrics.io/important-changes-to-coin-metrics-api-catalog-endpoints/.
    x-cm-gitbook:
      remove: true
  - name: Full catalog v2
    description: >-
      The Full catalog returns the full range of data that is supported by Coin
      Metrics across all our products.<br/> If you are a client looking to
      understand the data that is available for your API key and data license,
      please use the [Catalog](#tag/Catalog-v2) endpoint.
    x-cm-gitbook:
      tag: Catalog v2
      icon: layer-group
  - name: Timeseries
    description: >-
      Endpoints for fetching metrics, market data, indexes and other time series
      data.
    x-cm-gitbook:
      icon: chart-line
      renameOperationsTo: Timeseries REST
  - name: Timeseries stream
    description: >-
      WebSocket endpoints for getting a real-time stream of metrics, market
      data, indexes and other time series data.
    x-cm-gitbook:
      tag: Timeseries
      icon: wifi
  - name: Taxonomy
    description: Taxonomy endpoints
    x-cm-gitbook:
      icon: sitemap
  - name: Taxonomy Metadata
    description: Taxonomy Metadata endpoints
    x-cm-gitbook:
      tag: Taxonomy
      icon: tags
  - name: Profile
    description: Profile endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: id-card
  - name: List of blockchain entities v2
    description: Endpoints for fetching lists of blockchain entities.
    x-cm-gitbook:
      tag: ATLAS
      icon: list
  - name: Full blockchain entities v2
    description: Endpoints for fetching full blockchain entities.
    x-cm-gitbook:
      tag: List of blockchain entities v2
      icon: database
  - name: Jobs
    description: Jobs API endpoints
    x-cm-gitbook:
      tag: ATLAS
      icon: briefcase
  - name: Blockchain Explorer Job
    description: Endpoints for creating async jobs for blockchain entities.
    x-cm-gitbook:
      tag: ATLAS
      icon: clock
  - name: Blockchain Explorer Job Results
    description: Schema definitions of results of Blockchain Explorer Job endpoints.
    x-cm-gitbook:
      foldInto: Blockchain Explorer Job
  - name: Chain Monitor tools
    description: Endpoints for working with chain monitor data.
    x-cm-gitbook:
      tag: ATLAS
      icon: wrench
  - name: Security Master
    description: Security Master endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: shield
  - name: Constituent Snapshots
    description: Endpoints for getting the snapshots of various constituents
    x-cm-gitbook:
      tag: Meta Data
      icon: camera
  - name: Constituent Timeframes
    description: Endpoints for getting the timeframes of various constituents
    x-cm-gitbook:
      tag: Meta Data
      icon: calendar
  - name: Blockchain Metadata
    description: Blockchain metadata endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: database
  - name: Meta Data
    x-cm-gitbook:
      icon: database
  - name: ATLAS
    x-cm-gitbook:
      icon: map
  - name: Timeseries REST
    x-cm-gitbook:
      tag: Timeseries
      icon: table
paths:
  /timeseries-stream/market-openinterest:
    get:
      tags:
        - Timeseries stream
      summary: Market open interest
      description: >-
        Returns a WebSocket stream of open interests for specified markets.<br/>
        If you are falling behind (slow client) you will get `warning` message
        first, then `error` message and disconnection will happen.<br/><br/>
        <b>Note:</b> The `value_usd` field in this endpoint was previously
        calculated using hardcoded logic that no longer reflects current
        contract specifications across all exchanges.<br/><br/> To address this,
        we have deprecated the `value_usd` field and introduced new, more
        accurate metrics available via the `/timeseries/market-metrics`
        endpoint.<br/><br/> These two metrics should be used as a replacement
        for the `value_usd` field going forward:<br/> -
        `open_interest_reported_future_usd` to represent the notional value of
        open interest in U.S. dollars for futures markets<br/> -
        `open_interest_reported_option_notional_usd` to represent the notional
        value of open interest in U.S. dollars for options markets<br/><br/> We
        also introduced `open_interest_reported_option_market_value_usd` to
        represent the market value of open interest in U.S. dollars for options
        markets.
      operationId: getTimeseriesStreamMarketOpenInterest
      parameters:
        - $ref: '#/components/parameters/MarketId'
        - $ref: '#/components/parameters/Backfill'
        - $ref: '#/components/parameters/Pretty'
      responses:
        '401':
          $ref: '#/components/responses/Unauthorized'
        '403':
          $ref: '#/components/responses/Forbidden'
        '414':
          $ref: '#/components/responses/UriTooLong'
        default:
          $ref: '#/components/responses/StreamingMarketOpenInterests'
      security:
        - api_key: []
      servers:
        - url: wss://api.coinmetrics.io/v4
      x-codeSamples:
        - lang: JavaScript
          label: JavaScript
          source: >
            ws = new
            WebSocket("wss://api.coinmetrics.io/v4/timeseries-stream/market-openinterest?markets=binance-BTCUSDT-future&pretty=true&api_key=<your_key>")

            ws.onmessage = m => console.log(m.data); ws.onclose = () =>
            console.log("closed")
        - lang: Python
          label: Python
          source: >
            import asyncio

            import websockets


            async def handle(uri):
                async with websockets.connect(uri) as websocket:
                    while True:
                        print(await websocket.recv())

            asyncio.get_event_loop().run_until_complete(handle('wss://api.coinmetrics.io/v4/timeseries-stream/market-openinterest?markets=binance-BTCUSDT-future&pretty=true&api_key=<your_key>'))
components:
  parameters:
    MarketId:
      description: >-
        Comma separated list of markets or market patterns like `exchange-*` or
        `exchange-*-spot` or `*USDT-future`.<br/> Use a corresponding
        `/catalog-all-v2/market-{dataType}` endpoint for the full list of
        supported markets for a given data type.
      in: query
      name: markets
      required: true
      schema:
        type: array
        items:
          type: string
      explode: false
    Backfill:
      description: >-
        What data should be sent upon a connection.<br/> By default the latest
        values are sent just before real-time data.
      in: query
      name: backfill
      schema:
        type: string
        default: latest
        enum:
          - latest
          - none
    Pretty:
      description: Human-readable formatting of JSON responses.
      in: query
      name: pretty
      schema:
        type: boolean
        default: false
  responses:
    Unauthorized:
      description: Requested resource requires authorization.
      content:
        application/json:
          examples:
            unauthorized:
              summary: Unauthorized error response.
              value:
                error:
                  type: unauthorized
                  message: Requested resource requires authorization.
            wrong_credentials:
              summary: Wrong credentials error response.
              value:
                error:
                  type: wrong_credentials
                  message: Supplied credentials are not valid.
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    Forbidden:
      content:
        application/json:
          example:
            error:
              type: forbidden
              message: >-
                Requested metric 'SplyBMXNtv' with frequency '1d' for asset
                'btc' is not available with supplied credentials.
          schema:
            $ref: '#/components/schemas/ErrorResponse'
      description: Requested resource is not available with supplied credentials.
    UriTooLong:
      description: Provided URI is too long. It must not be greater than 10000 symbols.
    StreamingMarketOpenInterests:
      description: Open Interest WebSocket message.
      content:
        application/json:
          examples:
            new_openinterest:
              summary: Example of an open interest message.
              value:
                market: okex-EOS-USDT-231027-future
                time: '2023-10-26T06:06:00.000000000Z'
                contract_count: '5122'
                value_usd: '31121.272'
                exchange_time: '2023-10-26T06:06:00.000000000Z'
                cm_sequence_id: '126'
            warning:
              summary: Example of a warning message.
              value:
                warning:
                  type: falling_behind
                  message: >-
                    Your connection is falling behind and messages are being
                    queued for delivery to you. Your queue is now over 60% full.
                    You will be disconnected when the queue is full.
            error:
              summary: Example of an error message.
              value:
                error:
                  type: stall
                  message: >-
                    The client was reading too slowly and was disconnected by
                    the server.
          schema:
            $ref: '#/components/schemas/StreamingMarketOpenInterest'
  schemas:
    ErrorResponse:
      properties:
        error:
          $ref: '#/components/schemas/ErrorObject'
      required:
        - error
      type: object
    StreamingMarketOpenInterest:
      description: Market open interest WebSocket message.
      properties:
        market:
          $ref: '#/components/schemas/MarketId'
        time:
          $ref: '#/components/schemas/Time'
        contract_count:
          $ref: '#/components/schemas/ContractCount'
        value_usd:
          $ref: '#/components/schemas/ContractValueUSD'
          deprecated: true
        exchange_time:
          $ref: '#/components/schemas/OpenInterestExchangeTime'
        cm_sequence_id:
          $ref: '#/components/schemas/cmSequenceId'
      required:
        - market
        - time
        - contract_count
        - value_usd
        - cm_sequence_id
      type: object
    ErrorObject:
      properties:
        type:
          description: Error type string. Can be used for error identification.
          type: string
        message:
          description: >-
            Human-friendly error description. Can be amended without prior
            notification. Do not use for error identification in your code.
          type: string
      required:
        - type
        - description
      type: object
    MarketId:
      description: Unique name of the market.
      type: string
    Time:
      description: >-
        The time in ISO 8601 date-time format. Always with nanoseconds
        precision.
      type: string
      format: date-time
    ContractCount:
      description: Number of contracts. Returned as a decimal string.
      type: string
      format: decimal
    ContractValueUSD:
      deprecated: true
      description: >-
        Deprecated. Contract value in USD. This field was previously calculated
        using hardcoded logic that no longer reflects current contract
        specifications across all exchanges. Please use the new metrics
        available via `/timeseries/market-metrics` endpoint:
        `open_interest_reported_future_usd` for futures markets and
        `open_interest_reported_option_notional_usd` for options markets.
      type: string
      format: decimal
    OpenInterestExchangeTime:
      description: >-
        Time corresponding to the open interest data point. For open interest,
        this always equals `time`, since open interest is stored with a single
        timestamp rather than an independent exchange-reported time. Present for
        schema consistency with other market data types.
      type: string
      format: date-time
    cmSequenceId:
      description: The monotonically increasing message number, resets on disconnection.
      type: string
  securitySchemes:
    api_key:
      description: Coin Metrics API key can be specified as `?api_key=` query parameter.
      in: query
      name: api_key
      type: apiKey

````